---
- name: Create directories
  ansible.builtin.file:
    path: "{{ item }}"
    state: directory
    owner: "{{ ansible_ssh_user }}"
    group: "{{ ansible_ssh_user }}"
    mode: 0775
  with_items:
    - "{{ wireguard_path }}"
    - "{{ wireguard_data_path }}"
  become: true

- name: Generate docker-compose.yml
  ansible.builtin.template:
    src: "{{ wireguard_templates_path }}/docker-compose.yml.j2"
    dest: "{{ wireguard_path }}/docker-compose.yml"
    owner: "{{ ansible_ssh_user }}"
    group: "{{ ansible_ssh_user }}"
    force: true
    mode: 0644
    trim_blocks: false
  become: true

- name: Allow UDP connections
  ansible.builtin.iptables:
    chain: INPUT
    protocol: udp
    destination_ports:
      - "{{ wireguard_port | default('51820') }}"
    jump: ACCEPT
  become: true

- name: Allow TCP connections
  ansible.builtin.iptables:
    chain: INPUT
    protocol: tcp
    destination_ports:
      - "{{ wireguard_ui_port | default('80') }}"
    jump: ACCEPT
  become: true

- name: Start services
  community.docker.docker_compose:
    project_src: "{{ wireguard_path }}"
    project_name: "{{ wireguard_docker_instance }}"
    pull: true
